require "mailcover_rails/version"
require 'net/http'


class Mailcover
  attr_accessor :email, :api_key, :region

  def initialize(email)
    @email = email
    @api_key = Mailcover::API_KEY
    @region = Mailcover::REGION
  end

  def check_adress
    uri = URI.parse("https://#{region}.api.mailcover.com/#{api_key}/private/#{email}/json")
    res = Net::HTTP.post_form(uri, 'validation' => 'rails', 'max' => '200')
    answer = JSON.parse(res.body)
    answer
  end
end


class MailCoverValidator < ActiveModel::EachValidator
  def validate_each(record, attribute, value)
    return if value.blank?
    @record = record
    disposible = Mailcover::DISPOSIBLE
    @mailcover_responce = Mailcover.new(value).check_adress
    @record.errors.add(attribute, @mailcover_responce['reason']) if @mailcover_responce['status'] == 'invalid' || (disposible && @mailcover_responce['is_disposable'])
  end
end
